{-# LANGUAGE NoImplicitPrelude #-}
module Bamboo.Theme.Blueprint.Widget.Sidebar where

import Bamboo.Theme.Blueprint.Env hiding (rss_link)
import Bamboo.Theme.Blueprint.Widget.Helper
import qualified Bamboo.Model.Tag as Tag
import qualified Bamboo.Type.Config as C
import qualified Bamboo.Type.State as State
import qualified Bamboo.Type.StaticWidget as Sidebar
import qualified Data.Set as Set

sidebar :: Widget
sidebar s = 
  div_class_id "column span-3 last" "sidebar" 
    << unordList formatted_list
  where
    stock_list = 
      [ feed
      , tag_list $ s.State.tags
      ]
    
    custom_list =
      s
        .config
        .C.sidebar
        .map (\x -> h2 << x.Sidebar.name +++ x.markup)
    
    formatted_list = (stock_list ++ custom_list) .intersperse hr

    feed = toHtml
      [ h2 << "Subscribe"
      , p ! [theclass "feed"] << rss_link s
      ]

    rss_link = rss_url_link_pair >>> snd
    
    tag_list tags = toHtml
      [ h2 << "Tags"
      , unordList $ tags.Tag.sorted.map tag_link]
  
    tag_link x = 
      ( hotlink (s.env.slashed_script_name / x.Tag.uid) << x.Tag.name ) 
      +++ ( " (" ++ x.Tag.resources.Set.size.show ++ ")" )